import React from 'react';
import { EditorView } from '@codemirror/view';
import { Extension } from '@codemirror/state';
import { CodeMirrorOnChange, CodeMirrorOnExternalChange, CodeMirrorOnViewLifeCycle } from '@ui-schema/kit-codemirror/useCodeMirror';
export interface CodeMirrorComponentProps {
    onChange?: CodeMirrorOnChange;
    value?: string;
    extensions?: Extension[];
    classNamesContent?: string[];
    effects?: ((editor: EditorView) => void)[];
    style?: React.CSSProperties;
}
export interface CodeMirrorProps extends CodeMirrorComponentProps, Omit<React.HTMLProps<HTMLDivElement>, 'onChange' | 'value'> {
    onViewLifecycle?: CodeMirrorOnViewLifeCycle;
    onExternalChange?: CodeMirrorOnExternalChange;
    className?: string;
}
export declare const CodeMirror: React.FC<CodeMirrorProps>;
