"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CodeMirror = void 0;
var _react = _interopRequireDefault(require("react"));
var _view = require("@codemirror/view");
var _state = require("@codemirror/state");
var _useCodeMirror = require("@ui-schema/kit-codemirror/useCodeMirror");
var _useEditorClasses = require("@ui-schema/kit-codemirror/useEditorClasses");
var _excluded = ["classNamesContent", "onChange", "onViewLifecycle", "onExternalChange", "value", "extensions", "effects"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
var CodeMirror = exports.CodeMirror = function CodeMirror(_ref) {
  var classNamesContent = _ref.classNamesContent,
    onChange = _ref.onChange,
    onViewLifecycle = _ref.onViewLifecycle,
    onExternalChange = _ref.onExternalChange,
    _ref$value = _ref.value,
    value = _ref$value === void 0 ? '' : _ref$value,
    extensions = _ref.extensions,
    effects = _ref.effects,
    props = _objectWithoutProperties(_ref, _excluded);
  var containerRef = _react["default"].useRef(null);
  var editorAttributesCompartment = _react["default"].useRef(new _state.Compartment());
  var extensionsAll = _react["default"].useMemo(function () {
    return [editorAttributesCompartment.current.of(_view.EditorView.editorAttributes.of({}))].concat(_toConsumableArray(extensions || []));
  }, [extensions]);
  var editor = (0, _useCodeMirror.useCodeMirror)(onChange, value, extensionsAll, effects, containerRef, onExternalChange, onViewLifecycle);
  (0, _useEditorClasses.useEditorClasses)(editorAttributesCompartment.current, editor, classNamesContent);
  return _react["default"].createElement("div", _extends({
    ref: containerRef
  }, props));
};