"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.replaceWholeDoc = exports.createEditorView = void 0;
var _view = require("@codemirror/view");
var _state = require("@codemirror/state");
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var replaceWholeDoc = exports.replaceWholeDoc = function replaceWholeDoc(editor, nextValue) {
  editor === null || editor === void 0 || editor.dispatch({
    changes: {
      from: 0,
      to: editor.state.doc.length,
      insert: nextValue
    }
  });
};
var createEditorView = exports.createEditorView = function createEditorView(lastValueRef, extensions, onChangeRef, parent) {
  return new _view.EditorView({
    state: _state.EditorState.create({
      extensions: [].concat(_toConsumableArray(extensions || []), [_view.EditorView.updateListener.of(function (viewUpdate) {
        if (viewUpdate.view.destroyed) return;
        var texts = [undefined, undefined];
        if (viewUpdate.docChanged) {
          var next = viewUpdate.state.doc.toString();
          var prev = lastValueRef.current;
          lastValueRef.current = next;
          texts = [next, prev];
        }
        var onChange = onChangeRef === null || onChangeRef === void 0 ? void 0 : onChangeRef.current;
        if (!onChange) {
          return;
        }
        onChange(viewUpdate, texts[0], texts[1]);
      })]),
      doc: lastValueRef.current
    }),
    parent: parent
  });
};