"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useCodeMirror = void 0;
var _react = _interopRequireDefault(require("react"));
var _view = require("@codemirror/view");
var _state = require("@codemirror/state");
var _createEditorView = require("@ui-schema/kit-codemirror/createEditorView");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var useCodeMirror = exports.useCodeMirror = function useCodeMirror(onChange) {
  var _effects;
  var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var extensions = arguments.length > 2 ? arguments[2] : undefined;
  var effects = arguments.length > 3 ? arguments[3] : undefined;
  var containerRef = arguments.length > 4 ? arguments[4] : undefined;
  var onExternalChange = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : _createEditorView.replaceWholeDoc;
  var onViewLifecycle = arguments.length > 6 ? arguments[6] : undefined;
  var lastValueRef = _react["default"].useRef(value);
  var onChangeRef = _react["default"].useRef(undefined);
  var _React$useState = _react["default"].useState(undefined),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    editor = _React$useState2[0],
    setEditor = _React$useState2[1];
  onChangeRef.current = onChange;
  var readOnlyCompartment = _react["default"].useRef(new _state.Compartment());
  _react["default"].useLayoutEffect(function () {
    var editor = (0, _createEditorView.createEditorView)(lastValueRef, [].concat(_toConsumableArray(extensions || []), [readOnlyCompartment.current.of(_view.EditorView.editable.of(Boolean(onChangeRef.current)))]), onChangeRef);
    if (containerRef) {
      var _containerRef$current;
      (_containerRef$current = containerRef.current) === null || _containerRef$current === void 0 || _containerRef$current.append(editor.dom);
    }
    setEditor(editor);
    onViewLifecycle === null || onViewLifecycle === void 0 || onViewLifecycle(editor);
    return function () {
      onViewLifecycle === null || onViewLifecycle === void 0 || onViewLifecycle(editor, true);
      editor === null || editor === void 0 || editor.destroy();
      setEditor(undefined);
    };
  }, [containerRef, extensions, onViewLifecycle]);
  _react["default"].useEffect(function () {
    if (!editor) return;
    editor.dispatch({
      effects: readOnlyCompartment.current.reconfigure(_view.EditorView.editable.of(Boolean(onChange)))
    });
  }, [editor, onChange]);
  _react["default"].useLayoutEffect(function () {
    if (!editor) return;
    if (lastValueRef.current !== value) {
      var textA = editor.state.doc.toString();
      var textB = value;
      onExternalChange(editor, textB, textA);
      lastValueRef.current = textB;
    } else {
      lastValueRef.current = value;
    }
  }, [value, editor, onExternalChange, containerRef]);
  effects = ((_effects = effects) === null || _effects === void 0 ? void 0 : _effects.length) === 0 ? undefined : effects;
  _react["default"].useLayoutEffect(function () {
    if (!editor && effects) {
      console.error('received effects but editor is not ready', effects);
      return;
    }
    if (!effects || !editor) return;
    effects.forEach(function (effect) {
      effect(editor);
    });
  }, [effects, editor]);
  return editor;
};