"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useEditorClasses = void 0;
var _react = _interopRequireDefault(require("react"));
var _view = require("@codemirror/view");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
var useEditorClasses = exports.useEditorClasses = function useEditorClasses(compartment, editor, classNamesContent) {
  _react["default"].useEffect(function () {
    if (!editor || !classNamesContent || classNamesContent.length === 0) return;
    editor.dispatch({
      effects: compartment.reconfigure(_view.EditorView.editorAttributes.of({
        "class": classNamesContent.join(' ')
      }))
    });
    return function () {
      return editor.dispatch({
        effects: compartment.reconfigure(_view.EditorView.editorAttributes.of({
          "class": ''
        }))
      });
    };
  }, [compartment, editor, classNamesContent]);
};