"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useExtension = void 0;
var _state = require("@codemirror/state");
var _react = _interopRequireDefault(require("react"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
var useExtension = exports.useExtension = function useExtension(ext, deps) {
  var compartment = _react["default"].useRef(new _state.Compartment());
  var hasInit = _react["default"].useRef(false);
  var extRef = _react["default"].useRef(ext);
  extRef.current = ext;
  var init = _react["default"].useCallback(function () {
    hasInit.current = true;
    return compartment.current.of(extRef.current());
  }, []);
  var effects = _react["default"].useMemo(function () {
    if (!hasInit.current) return undefined;
    return [function updateExtension(editor) {
      editor.dispatch({
        effects: compartment.current.reconfigure(extRef.current())
      });
    }];
  }, deps || []);
  return {
    init: init,
    effects: effects
  };
};